local Me=CreateFrame("Frame","vZifnabsTargets")
vZifnabs.mod.targets=Me
local mod=vZifnabs.mod
local L={}
local db=nil

local widget={}
local pfx="vZifnabs_Targets"
local delay=1
local resultlist=nil
local playername=UnitName("player")
local party={}
local about={}
local info_entry=nil
local damage_by_player=""
local MINDELTADISTANCE=0.1
local tooltop=nil
local ticktack=0

-- Slash Commands
SLASH_VZIFNABSTARGETS1 = "/zt"
SlashCmdList["VZIFNABSTARGETS"]=function (parm) Me:Command(parm) end

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db,L=mod.core:InitStart("targets")	
	if not db.targets then db.targets={enabled=true, seen={}, waypoint={}} end
	
	widget={frame=getglobal(pfx),text=getglobal(pfx.."_Text"),
			cframe=getglobal(pfx.."_CommentFrame"),ctext=getglobal(pfx.."_CommentFrame_Text"),
			cup=getglobal(pfx.."_Up"),cdown=getglobal(pfx.."_Down"),
			sframe=getglobal(pfx.."_SearchFrame"),stext=getglobal(pfx.."_SearchFrame_Text"),
			known=getglobal(pfx.."_Known"),
			}
	
	widget.mm=getglobal(pfx.."_MM")
	widget.mm:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
	widget.mm:SetBackdropColor(0,0,1,1);
	widget.wm={}
	for nr=1,10,1 do
		widget.wm[nr]=getglobal(pfx.."_WM_"..nr)
		widget.wm[nr]:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.wm[nr]:SetBackdropColor(1,0,0,1);
		widget.wm[nr]:Hide()
	end
	widget.wminfo=getglobal(pfx.."_WMinfo")
	widget.wmtext=getglobal(pfx.."_WMinfo_Text")
	widget.wmtext:SetTextColor(1,0,0,1)
	
	mod.core:RegisterButton("targets","reshow",L.button.targets.reshow)
	mod.core:RegisterButton("targets","search",L.button.targets.search)
	mod.core:RegisterButton("targets","history",L.button.targets.history)
	mod.core:RegisterButton("targets","hide",L.button.targets.hide,"vZifnabs_Targets_Hide")
	mod.core:RegisterButton("targets","up",L.button.targets.up,"vZifnabs_Targets_Up")
	mod.core:RegisterButton("targets","down",L.button.targets.down,"vZifnabs_Targets_Down")
	mod.core:RegisterButton("targets","edit",L.button.targets.comment,"vZifnabs_Targets_Comment")
	mod.core:RegisterButton("targets","save",L.button.targets.save,"vZifnabs_Targets_CommentFrame_Save")
	mod.core:RegisterButton("targets","abort",L.button.targets.abort,"vZifnabs_Targets_CommentFrame_Abort")
	mod.core:RegisterButton("targets","srun",L.button.targets.srun,"vZifnabs_Targets_SearchFrame_Run")
	mod.core:RegisterButton("targets","sabort",L.button.targets.sabort,"vZifnabs_Targets_SearchFrame_Abort")

	mod.core:RegisterButton("targets","setmm",L.button.targets.setmm,"vZifnabs_Targets_SetMM")	
	mod.core:RegisterButton("targets","known",L.button.targets.known,"vZifnabs_Targets_Known")

	Me:Cleanup()
end
	
function Me:Activate()		
	mod.core:RegisterEvent("PLAYER_TARGET_CHANGED","targets",Me.PLAYER_TARGET_CHANGED)
	mod.core:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH","targets",Me.DEATH)
	mod.core:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS","targets",Me.COMBAT)
	mod.core:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE","targets",Me.COMBAT)
	mod.core:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE","targets",Me.COMBAT)
	mod.core:RegisterEvent("PLAYER_REGEN_DISABLED","target",Me.COMBAT_START)
	mod.core:RegisterEvent("PLAYER_REGEN_ENABLED","target",Me.COMBAT_END)
	mod.core:RegisterEvent("PARTY_MEMBERS_CHANGED","target",Me.PARTY_MEMBERS_CHANGED)
	mod.core:RegisterEvent("TICK","targets",Me.Tick)
	mod.core:RegisterEvent("ONUPDATE","targets",Me.OnUpdate)
	mod.core:RegisterEvent("WORLD_MAP_UPDATE","targets",Me.WORLD_MAP_UPDATE);
	widget.mm:Show()
	widget.wminfo:Show()
end

function Me:Deactivate()
	mod.core:DeRegisterEvent("PLAYER_TARGET_CHANGED","targets")
	mod.core:DeRegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH","targets")
	mod.core:DeRegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS","targets")
	mod.core:DeRegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE","targets")
	mod.core:DeRegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE","targets")
	mod.core:DeRegisterEvent("PLAYER_REGEN_DISABLED","target")
	mod.core:DeRegisterEvent("PLAYER_REGEN_ENABLED","target")
	mod.core:DeRegisterEvent("PARTY_MEMBERS_CHANGED","target")
	mod.core:DeRegisterEvent("TICK","targets")
	mod.core:DeRegisterEvent("ONUPDATE","targets")
	mod.core:DeRegisterEvent("WORLD_MAP_UPDATE","targets");
	widget.frame:Hide()
	widget.wminfo:Hide()
	for nr=1,10,1 do widget.wm[nr]:Hide() end
	widget.mm:Hide()
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:OnUpdate()
	local tt=getglobal("GameTooltipTextLeft1"):GetText()
	if tt and tt~=tooltip then
		tooltip=tt
		if string.find(tt,"Corpse of ")==1 then
			tt=string.sub(tt,11)
			if db.targets.seen[tt] then Me:TellAbout(tt) else Me:TellAbout(tt,tt.." is unknown") end
		else
			local t2=getglobal("GameTooltipTextLeft2"):GetText()
			if string.find((t2 or ""),"(Player)") and not party[tt] then
				local word=mod.core:Split(tt," ")
				for n=1,3,1 do
					if word[n] then tt=word[n] end
				end
				if db.targets.seen[tt] then 
					word=mod.core:Split(t2," ")
					if word[2]~="??" then db.targets.seen[tt].lvl=word[2] end
					Me:TellAbout(tt) 
					local x,y,zone,position=mod.locator:GetLoc()
					Me:insertPos(tt,position)
				else
					Me:TellAbout(tt,tooltip..", "..string.sub(t2,1,string.find(t2,"(Player)")-2))
				end
			end
		end
	end
end

function Me:Tick()
	if not UnitExists("target") and delay>0 then
		delay=delay-1
		if delay==0 then widget.frame:Hide() end
	end
	Me:MapTick()
end

function Me:MapTick()
	local x,y,zone=mod.locator:GetLoc()
	local waypoint=db.targets.waypoint[UnitName("player")]
	local color={red=0,green=0,blue=1}
	local mmradius=Minimap:GetWidth() / 2
	local point={x=0,y=-(mmradius-8),zx=0,zy=0,tt=""}
	local tick=0
	if waypoint then 
		color={red=1,green=1,blue=1}
		local ptr=waypoint.pos.n
		for n=1,10,1 do
			local pos=waypoint.pos[ptr]
			if pos then
				local wx,wy,wzone=mod.locator:ParseLoc(pos)
				if wzone==zone and not point.pos then point.pos=pos end
			end
			ptr=ptr-1
			if ptr==0 then ptr=10 end
		end
		if not point.pos then point.pos=waypoint.pos[waypoint.pos.n] end
		local wx,wy,wzone=mod.locator:ParseLoc(point.pos)

		if wzone~=zone then point.tt=wzone.." ("..wx.."/"..wy..")"
		else
			local distance=math.sqrt((x-wx)*(x-wx)+(y-wy)*(y-wy))
			point.tt="("..wx.."/"..wy..") >>"..math.floor(10*distance)/10
			local unscaledx,unscaledy,mmscalex,mmscaley=mod.locator:GetMinimapScale()
			local mmx=(wx-x)*mmradius/mmscalex
			local mmy=(y-wy)*mmradius/mmscaley
			local mmdistance=sqrt(mmx * mmx + mmy * mmy)
			if mmdistance < mmradius-4 then
				point.x=mmx
				point.y=mmy
			else
				point.x=mmx*(mmradius-4)/mmdistance
				point.y=mmy*(mmradius-4)/mmdistance
			end	
			if mmdistance<mmradius then			color={red=0,green=1,blue=0}
			elseif mmdistance<2*mmradius then	color={red=0.5,green=1,blue=0}
			elseif mmdistance<3*mmradius then	color={red=1,green=0.5,blue=0}
			end
			ticktack=ticktack+1
			if ticktack>3 then ticktack=0 end
			tick=math.floor(ticktack/2)
		end
	end
	if (waypoint) then point.tt=waypoint.name.."\n"..point.tt end
	widget.mm:SetPoint("CENTER","Minimap","CENTER",point.x,point.y)
	if (tick==0) then 
		widget.mm:SetBackdropColor(color.red,color.green,color.blue,1)
	else 
		widget.mm:SetBackdropColor(1,1,1,1)
	end
	widget.mm.tooltipText=point.tt
end

-- -----------------------------------------------------------------
-- BUTTON
-- -----------------------------------------------------------------
function Me:Button(button,fnk)
	if fnk=="hide" and resultlist then 
		resultlist=nil
		widget.cdown:Hide()
		widget.cup:Hide()
		button:SetText(L.button.targets.hide.text)
		button.tooltipText=L.button.targets.hide.tt
	elseif fnk=="hide" then
		widget.frame:Hide()
		db.targets.enabled=false
	elseif fnk=="reshow" then 
		widget.frame:Show()
		db.targets.enabled=true
	elseif fnk=="up" and resultlist and  resultlist.ix>1 then
		Me:TargetInfo(resultlist.ix-1,true)
	elseif fnk=="down" and resultlist and resultlist.ix<resultlist.max then
		Me:TargetInfo(resultlist.ix+1,true)
	elseif fnk=="edit" and info_entry then
		widget.ctext:SetText(db.targets.seen[info_entry].comment or "")
		widget.cframe:Show()
		widget.sframe:Hide()
	elseif fnk=="save" then
		if resultlist.ix and resultlist[resultlist.ix] then 
			db.targets.seen[resultlist[resultlist.ix]].comment=widget.ctext:GetText()
		else
			mod.core:Print("INTERNAL ERROR: no index for resultlist. maybe "..(info_entry or "nil").." can be used?","RaidWarning")
		end
		widget.cframe:Hide()
	elseif fnk=="abort" then
		widget.cframe:Hide()
	elseif fnk=="history" then
		Me:SearchTargets()
	elseif fnk=="search" then
		widget.frame:Show()
		widget.sframe:Show()
		widget.cframe:Hide()
	elseif fnk=="sabort" then
		widget.sframe:Hide()
	elseif fnk=="srun" then
		widget.sframe:Hide()
		Me:Search(widget.stext:GetText())
	elseif fnk=="setmm" and info_entry then
		Me:SetMM(info_entry,db.targets.seen[info_entry].pos)
	elseif fnk=="known" and info_entry then
		if not db.targets.seen[info_entry].known then db.targets.seen[info_entry].known={} end
		db.targets.seen[info_entry].known[playername]=not db.targets.seen[info_entry].known[playername]
		if db.targets.seen[info_entry].known[playername] then 
			widget.known:SetText("-")
			widget.known.tooltipText=L.button.targets.unknown.tt
		else
			widget.known:SetText("+")
			widget.known.tooltipText=L.button.targets.known.tt
		end
	elseif fnk=="MM" or fnk=="WM" then
		local x,y,zone,pos=mod.locator:GetLoc()
		if fnk=="MM" and db.targets.waypoint[UnitName("player")] then	
			db.targets.waypoint[UnitName("player")]=nil
			for n=1,10,1 do widget.wm[n]:Hide()	end
			widget.wminfo:Hide()
		elseif fnk=="MM" then
			Me:SetMM(zone.." "..date("%d.%m.%y, %H:%M:%S",time()),{["n"]=1,[1]=pos})
		elseif fnk=="WM" then
			local split=mod.core:Split(button:GetName(),"_")
			local n=tonumber(split[4])
			if db.targets.waypoint[UnitName("player")].pos[n] then db.targets.waypoint[UnitName("player")].pos.n=n end
		end	
	end
end

-- -----------------------------------------------------------------
-- SET MM
-- -----------------------------------------------------------------
function Me:SetMM(setname,pos)
	local waypoint={name=setname,pos={}}
	waypoint.pos.n=pos.n
	for n=1,10,1 do
		waypoint.pos[n]=pos[n]
	end
	db.targets.waypoint[UnitName("player")]=waypoint
end

-- -----------------------------------------------------------------
-- WORLD MAP
-- -----------------------------------------------------------------
function Me:WORLD_MAP_UPDATE(a1,a2,a3,a4)
	local waypoint=db.targets.waypoint[UnitName("player")]
	if waypoint and WorldMapFrame:IsVisible() then 
		local continent = GetCurrentMapContinent()
		local zonelist={GetMapZones(continent)}
		local zone=zonelist[GetCurrentMapZone()]
		if L.locator.zonereplace[zone] then zone=L.locator.zonereplace[zone] end

		widget.wmtext:SetText(waypoint.name or "?")
		for n=1,10,1 do
			local pos=waypoint.pos[n]
			local show=pos
			if pos then 
				local wx,wy,wzone=mod.locator:ParseLoc(pos)
				wx=wx*WorldMapDetailFrame:GetWidth()/100
				wy=wy*WorldMapDetailFrame:GetHeight()/100
				widget.wm[n]:SetPoint("CENTER","WorldMapDetailFrame","TOPLEFT",wx,-wy)
				show=(wzone==zone)
			end
			if show then widget.wm[n]:Show() else widget.wm[n]:Hide() end
		end
	elseif not waypoint then widget.wmtext:SetText("")
	end
end

-- -----------------------------------------------------------------
-- PARTY MEMBERS CHANGED
-- -----------------------------------------------------------------
function Me:PARTY_MEMBERS_CHANGED()
	party={}
	for t=1,5,1 do
		local name=UnitName("party"..t)
		if name then 
			party[name]=t
			Me:PLAYER_TARGET_CHANGED(nil,nil,"party"..t)
			if not db.targets.seen[name].known then 
				db.targets.seen[name].known={} 
			end
			if not db.targets.seen[name].known[playername] then 
				db.targets.seen[name].known[playername]=true
				mod.core:Print(mod.core:Repl(L.msg.markedknown,"<name>",name))
			end
		end
	end
end

-- -----------------------------------------------------------------
-- TARGET CHANGED
-- -----------------------------------------------------------------
function Me:PLAYER_TARGET_CHANGED(ignore,alsoignore,givenunit)
	local unit=givenunit or "target"
	local name=UnitName(unit)
	if UnitExists(unit) and name~=playername and name~=UnitName("pet") then
		if not db.targets.seen[name] then db.targets.seen[name]={} end
		local entry=db.targets.seen[name]
		local lrace,race=UnitRace(unit)
		entry.race=race
		entry.class=UnitClass(unit)
		entry.family=UnitCreatureFamily(unit)
		entry.sex=UnitSex(unit)
		entry.faction=UnitFactionGroup(unit)
		entry.npc=not UnitIsPlayer(unit)
		entry.classify=UnitClassification(unit)
		if entry.classify=="normal" then entry.classify=nil end
		entry.guild=GetGuildInfo(unit)
		local x,y,zone,position=mod.locator:GetLoc()
		local by=entry.by or {}
		if not by[playername] then by[playername]={} end
		by[playername].first=by[playername].first or time()
		by[playername].last=time()
		entry.by=by
		local lvl=UnitLevel(unit)
		if (lvl=="??" or lvl==nil) then entry.lvl=entry.lvl or lvl else entry.lvl=lvl end
		if db.targets.enabled and not resultlist and not givenunit then Me:TargetInfo(name) end
		if not giveunit then Me:insertPos(name,position) end
	elseif not resultlist then 
		delay=50
	end
end

-- -----------------------------------------------------------------
-- COMBAT START/END
-- -----------------------------------------------------------------
function Me:COMBAT_START() damage_by_player="" end
function Me:COMBAT_END() damage_by_player="" end

-- -----------------------------------------------------------------
-- DEATH
-- -----------------------------------------------------------------
function Me:DEATH(event,arg1)
	if string.lower(arg1)==L.keyword.youdie and damage_by_player~="" then
		local x,y,zone,pos=mod.locator:GetLoc()
		local enemyfaction=L.keyword.HORDE
		if UnitFactionGroup("player")==enemyfaction then enemyfaction=L.keyword.ALLIANCE end
	
		local list=mod.core:Split(mod.core:Trim(damage_by_player)," ")
		mod.core:PrintInfo(mod.core:Repl(L.msg.diedfrom,{"<name>","<count>"},{damage_by_player,getn(list)}))
		for nr=1,getn(list),1 do
			local enemy=list[nr]
			if not db.targets.seen[enemy] then db.targets.seen[enemy]={by={[playername]={first=time(),last=time()}},npc=false,faction=enemyfaction} end
			if not db.targets.seen[enemy].by[playername] then db.targets.seen[enemy].by[playername]={first=time()} end
			db.targets.seen[enemy].by[playername].last=time()
			Me:insertPos(enemy,pos)
			if not db.targets.seen[enemy].kills then db.targets.seen[enemy].kills={} end
			if not db.targets.seen[enemy].kills[playername] then db.targets.seen[enemy].kills[playername]={} end
			db.targets.seen[enemy].kills[playername][time()]=true
			local count=0
			for tm,dummy in pairs(db.targets.seen[enemy].kills[playername]) do
				count=count+1
			end
			mod.core:Print(mod.core:Repl(L.msg.killedby,{"<enemy>","<times>"},{enemy,count}))
		end
	end
end

-- -----------------------------------------------------------------
-- COMBAT DAMAGE
-- -----------------------------------------------------------------
function Me:COMBAT(event,arg1,arg2,arg3,arg4)
	local lowarg1=string.lower(arg1)
	if string.find(" "..lowarg1,L.keyword.ByouB) then
		local hostile=nil
		if event=="CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS" then
			hostile=string.sub(arg1,1,string.find(arg1," ")-1)
		elseif event=="CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" then 
			local eon=string.find(arg1,"'")
			for n=1,10,1 do eon=string.find(arg1,"'",eon+1) or eon end
			hostile=string.sub(arg1,1,eon-1)
		elseif event=="CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" then
			local from=string.find(lowarg1,L.keyword.BfromB) --You suffer nn wtf damage from hostile's wtf spell
			if from then from=from+string.len(L.keyword.BfromB) end
			local stopname=string.find(lowarg1,"'")
			local sn=stopname
			while sn do
				stopname=sn
				sn=string.find(lowarg1,"'",stopname+1)
			end
			if stopname then stopname=stopname-1 end
			if string.find(lowarg1,L.keyword.youabsorb) then
				local sl=string.len(L.keyword.youabsorb)
				hostile=string.sub(arg1,sl+2,stopname)
			elseif string.find(lowarg1,L.keyword.yougain) then 
				hostile=nil
			elseif from and stopname then 
				hostile=string.sub(arg1,from,stopname)
			elseif not string.find(arg1,L.keyword.afflicted) then 
			end
		end
		if hostile and string.find(hostile," ") then
			hostile=nil
		elseif hostile and db.targets.seen[hostile] and db.targets.seen[hostile].npc then
			hostile=nil
		elseif hostile and not string.find(damage_by_player," "..hostile.." ") then 
			mod.core:Print(mod.core:Repl(L.msg.damageby,"<enemy>",hostile))
			damage_by_player=damage_by_player.." "..hostile.." " 
		end
	end
end

-- -----------------------------------------------------------------
-- TARGET INFO
-- -----------------------------------------------------------------
function Me:TargetInfo(entry,locinfo)
	delay=-1
	if type(entry)=="number" then
		resultlist.ix=entry
		if entry>1 then widget.cup:Show() else widget.cup:Hide() end
		if entry<resultlist.max then widget.cdown:Show() else widget.cdown:Hide() end
		entry=resultlist[entry]
	else
		widget.cdown:Hide()
		widget.cup:Hide()
	end

	info_entry=entry
	local info=db.targets.seen[entry]
	local report=entry
	if not info then
		if about[entry] then report=about[entry].text.."\nnot in db" end
	else
		if not info.mark then
			if info.sex~=1 then report=report.." ("..(L.keyword.sex[info.sex] or info.sex or "nil")..")" end
			if info.faction then report=report..", "..info.faction end
			if info.guild then report=report..", "..info.guild end
			report=report.."\n"..(info.class or "no class")
			if info.family then report=report..", "..info.family end
			if info.race then report=report..", "..info.race end
			if not info.lvl or info.lvl==-1 then report=report..", Lvl ??" else report=report..", Lvl "..info.lvl end
			if info.classify then report=report.." ("..info.classify..")" end
		end
		if info.kills then
			local killed=0
			local killedchar=0
			for name,list in pairs(info.kills) do
				for tm,dummy in pairs(list) do
					killed=killed+1
					if name==playername then killedchar=killedchar+1 end
				end
			end
			report=report.."\n"..mod.core:Repl(L.msg.killreport,{"<times>","<alltimes>"},{killedchar,killed})
		end
		if info.comment then report=report.."\n"..info.comment end
		if not info.npc and not party[entry] then Me:TellAbout(entry) end
		if (locinfo or not info.npc) and info.pos then 
			local x,y,zone=mod.locator:ParseLoc(info.pos[info.pos.n])
			local last=0
			for player,tm in pairs(info.by) do
				if tm.last>last then last=tm.last end
			end
			report=report.."\n"..date("%d.%m.%y, %H:%M:%S",math.floor(last))
			local nr=info.pos.n
			if nr then
				for nrc=1,10,1 do
					local posnr=info.pos[nr]
					if posnr~=nil then 
						local x,y,zone=mod.locator:ParseLoc(posnr)
						if nrc==1 then report=report.." " else report=report.."\n" end
						report=report..zone.." ("..x.."/"..y..")"
					end
					nr=nr-1
					if nr==0 then nr=10 end
				end
			end
		end
	end
	if resultlist then report=resultlist.ix.."/"..resultlist.max..": "..(report or "") end
	widget.text:SetText(report)
	local but=L.button.targets.known
	if info and info.known and info.known[playername] then but=L.button.targets.unknown end
	widget.known:SetText(but.text)
	widget.known.tooltipText=but.tt
	widget.frame:Show()
	widget.cframe:Hide()
end

-- -----------------------------------------------------------------
-- TELL ABOUT
-- -----------------------------------------------------------------
function Me:TellAbout(who,infoline)
	info=db.targets.seen[who]
	if not party[who] and (not about[who] or time()-about[who].last>30) then
		local kills=0
		local text=infoline or who..", Level "..(info.lvl or "??").." "..(info.race or "unknown").." "..(info.class or "unknown")..", "..(L.keyword.sex[info.sex] or "unknown").." (db)"
		if not infoline and info.pos then 
			local x,y,zone=mod.locator:ParseLoc(info.pos[info.pos.n]) 
			text=text.."\n"..zone.." ("..x.."/"..y..")"
		end
		if info then
			if info.comment then mod.core:Print(info.comment) end
			if info.kills then
				for character,list in pairs(info.kills) do
					for datetime,dummy in pairs(list) do
						kills=kills+1
						text=text.."\nkilled "..character.." on "..date("%d.%m.%y, %H:%M:%S",datetime)
					end
				end
			end
		end
		if kills==0 then 
			mod.core:Print(mod.core:Color(text,"cccc88"),nil,true)
		else
			mod.core:Print(mod.core:Color(text,"ffaa44"),nil,true)
			PlaySoundFile("Interface\\AddOns\\vZifnabs\\dingding.mp3","Master")
		end
		about[who]={last=time(),text=text}
		if not about.history then about.history={nr=0} end
		about.history.nr=about.history.nr+1
		about.history[about.history.nr]=who
	end
end

-- -----------------------------------------------------------------
-- SLASH COMMAND
-- -----------------------------------------------------------------
function Me:Command(parm)
	local split=mod.core:Split(parm," ",2)
	local cmd=string.lower(mod.core:Trim(split[1]))
	-- show group information
	if cmd=="group" then
		for p=1,5,1 do
			local id="party"..p
			if UnitExists(id) then
				local info=db.targets.seen[UnitName(id)]
				local text=""
				if not info then text="never seen"
				elseif not info.comment then text="no comments"
				else text=info.comment
				end
				mod.core:Print(UnitName(id)..": "..text)
			end
		end
	-- cleanup database
	elseif cmd=="delete" then
		if not db.targets.seen[split[2]] then mod.core:Print(mod.core:Repl(L.msg.nomatchfound,"<search>",(split[2] or "nil")))
		else
			db.targets.seen[split[2]]=nil
			mod.core:Print(mod.core:Repl(L.msg.delfromdb,"<name>",split[2]))
		end
	-- check group for comments
	elseif cmd=="comments" then
		for name,info in pairs(db.targets.seen) do
			if (info.comment or "")~="" then mod.core:Print(name..": "..info.comment) end
		end
	-- store a landmark
	elseif cmd=="mark" and split[2] then
		split=mod.core:Split(split[2],",",2)
		local name=split[1]
		local comment=split[2]
		local x,y,zone,pos=mod.locator:GetLoc()
		if not db.targets.seen[name] then db.targets.seen[name]={} end
		local entry=db.targets.seen[name]
		if entry.npc or entry.class or entry.race or entry.family then mod.core:Print(mod.core:Repl(L.msg.nameinuse,"<name>",name))
		else 
			db.targets.seen[name]={mark=true,by={[playername]={first=time(),last=time()}},comment=comment}
			local x,y,zone,pos=mod.locator:GetLoc()
			Me:insertPos(name,pos)
		end
	-- search in database
	elseif cmd=="targets" then
		Me:SearchTargets()
	else
		Me:Search(parm)
	end
end

function Me:IsKnown(name) return (db.targets.seen[name] and db.targets.seen[name].known and db.targets.seen[name].known[playername]) end

-- -----------------------------------------------------------------
-- SEARCH
-- -----------------------------------------------------------------
function Me:SearchTargets()
	if not about.history then mod.core:Print(L.msg.nohistory)
	else
		local alreadyin={}
		resultlist={ix=0,max=0}
		for nr=about.history.nr,1,-1 do
			local entry=about.history[nr]
			if not alreadyin[entry] then
				local rnr=resultlist.ix+1
				resultlist.max=rnr
				resultlist.ix=rnr
				resultlist[rnr]=entry
				alreadyin[entry]=true
			end
		end
		local button=getglobal("vZifnabs_Targets_Hide")
		button:SetText(L.button.targets.hides.text)
		button.tooltipText=L.button.targets.hides.tt
		if resultlist.max==0 then 
			resultlist=nil
			mod.core:Print(mod.core:Repl(L.msg.nomatchfound,"<search>","?"))
		else
			Me:TargetInfo(resultlist.max,true)
		end
	end
end
function Me:Search(what)
	local searchparm=what
	local selector={}
	while what do
		local split=mod.core:Split(what," ",2)
		local word=string.lower(mod.core:Trim(split[1]))
		if word=="player" then selector.ctype="player"
		elseif word=="npc" then selector.ctype="npc"
		elseif word=="kills" then selector.kills=true
		elseif word=="horde" then selector.faction="Horde"
		elseif word=="ally" then selector.faction="Alliance"
		elseif word=="known" then selector.known=true
		elseif word=="notonce" then selector.notonce=true
		elseif word=="byme" then selector.byme=true
		else break
		end
		what=mod.core:Trim(split[2])
	end
	local list={}
	local listentry={}
	local nr=0
	local dbsize=0
	local kills={}
	for name,info in pairs(db.targets.seen) do
		dbsize=dbsize+1
		local take=true		
		if selector.ctype=="player" and info.npc then take=false
		elseif selector.ctype=="npc" and not info.npc then take=false
		elseif selector.kills and (not info.kills or not info.kills[playername]) then take=false
		elseif selector.faction and selector.faction~=info.faction then take=false
		elseif selector.known and not (info.known and info.known[playername]) then take=false
		elseif selector.byme and not (info.by and info.by[playername]) then take=false
		elseif selector.notonce and (not info.by[playername] or (info.by[playername].first==info.by[playername].last)) then take=false
		elseif what and not string.find(string.lower(name.." "..(info.guild or "").." "..(info.class or "").." "..(info.race or "").." "..(info.comment or "")),what) then take=false
		end

		if take then 
			nr=nr+1
			local last=0
			for player,tm in pairs(info.by) do
				if tm.last>last then last=tm.last end
			end
			if not list[last] then 
				list[last]={} 
				listentry[1+getn(listentry)]=last
			end
			list[last][1+getn(list[last])]=name
			if selector.kills and info.kills and info.kills[playername] then
				for datetime,dummy in pairs(info.kills[playername]) do
					kills[datetime]=true
				end
			end
		end
	end
	if nr==0 then 
		resultlist=nil
		mod.core:Print(mod.core:Repl(L.msg.nomatchfound,"<search>",searchparm))
	else
		resultlist={ix=1,max=nr}
		table.sort(listentry)
		for le=1,getn(listentry),1 do
			local datetimesequence=listentry[le]
			local info=list[datetimesequence]
			for ix=1,getn(info),1 do
				resultlist[nr]=info[ix]
				nr=nr-1
			end
		end
		local button=getglobal("vZifnabs_Targets_Hide")
		button:SetText(L.button.targets.hides.text)
		button.tooltipText=L.button.targets.hides.tt
		Me:TargetInfo(1,true)
	end
end

function Me:insertPos(entry,position)
	if not db.targets.seen[entry] then db.targets.seen[entry]={} end
	if not db.targets.seen[entry].pos then db.targets.seen[entry].pos={n=0} end
	local nr=1+db.targets.seen[entry].pos.n
	if nr>10 then nr=1 end
	local sx,sy,szone=mod.locator:ParseLoc(position)
	local nearest=0
	local distance=MINDELTADISTANCE
	for n=1,10,1 do
		local pos=db.targets.seen[entry].pos[n]
		if pos then
			local px,py,pzone=mod.locator:ParseLoc(pos)
			if pzone==szone then
				local dist=math.sqrt((px-sx)*(px-sx)+(py-sy)*(py-sy))
				if dist<distance then
					distance=dist
					nearest=n
				end
			end
		end
	end
	if nearest==0 then 
		db.targets.seen[entry].pos.n=nr
	else
		nr=nearest
	end
	db.targets.seen[entry].pos[nr]=position
end

function Me:Cleanup()
	local count={keep=0,delete=0}
	local now=time()
	for name,info in pairs(db.targets.seen) do
		if not info.npc and not info.mark then
			local keep=false
			if info.kills or info.comment or info.known then keep=true
			elseif info.by then
				for who,when in pairs(info.by) do
					if when.first~=when.last or now-when.first<7*24*3600 then keep=true end
				end
			end
			if keep then count.keep=count.keep+1
			else
				mod.core:Print(mod.core:Repl(L.msg.delfromdb,"name",name))
				count.delete=count.delete+1
				db.targets.seen[name]=nil
			end
		end
	end
	mod.core:Print(mod.core:Repl(L.msg.cleanup,{"<keep>","<delete>"},{count.keep,count.delete}))
end